/*
 * 
 * */

package eCommerce.methods;

import java.util.ArrayList;
import java.lang.String;

public class RandomMethods
{
  //DEBUGGING SECTION - DELETE BEFORE TURNING IN!
  /*
  public static void main(String[] args)
  {
    RandomMethods ran = new RandomMethods();
  }
  
  RandomMethods()
  {
  }
  //DEBUGGING SECTION - DELETE BEFORE TURNING IN! */
  
  private String age;
  private String userName = "";
  private String currentPage= "entrance.html";
  private String errorMsg = "";
  private final String serverPass = "password";
  
  private ArrayList items = new ArrayList();
  
  private boolean sessionVar = true;
  private boolean isAdmin = false;
  private boolean isCustom = false;
  private boolean loggedIn = false;
  
  
  //GETTING RANDOM VARIABLES
  
  //Returns server pass
  public String getPass()
  { return serverPass; }
  
  //Determines if user is a customer
  public void setCustom(boolean isCustom)
  { this.isCustom = isCustom; }

  //Tells server if user is a customer
  public boolean getCustom()
  { return isCustom; }
  
  //sets login
  public void setLoggedIn(boolean loggedIn)
  { this.loggedIn = loggedIn; }
  
  //returns whether user is logged in
  public boolean getLoggedIn()
  { return loggedIn; }
  
  //Determines if user is an administrator
  public void setAdmin(boolean isAdmin)
  { this.isAdmin = isAdmin; }
  
  //Says if user is an administrator
  public boolean getAdmin()
  { return isAdmin; }
  
  //Sets userName string
  public void setUserName(String userName)
  {
    this.userName = userName;
  }
  
  //Returns userName
  public String getUserName()
  {
    if(userName.equals(""))
    {
        return "Customer";
    }
    return userName;
  }
  
  //Sets age string as "yes" if 21 and "no" if younger
  public void setAge(String age)
  { this.age = age; }
  
  //Returns age
  public String getAge()
  { return age; }
  
  //Returns sessionVar
  public boolean getSession()
  { return sessionVar; }
  
  //Sets sessionVar
  public void setSession(boolean sessionVar)
  { this.sessionVar = sessionVar; }
  
  //Sets currentPage equal to the last page visited
  public void setPage(String page)
  { currentPage = page; }
  
  //Returns currentPage
  public String getPage()
  { return currentPage; }
  
  
  //METHODS CORROSPONDING TO SIGN-UP PAGE
  
  public String getErrorMsg()
  { return errorMsg; }
  
  public void setErrorMsg(String errorMsg)
  { this.errorMsg = errorMsg; }
  
  
  //FIELD CHECKING SECTION
  
  //checks to see if the name is valid
  public boolean checkNorm(String name)
  {
    String alpha = "abcdefghijklmnopqrstuvwxyz";
    name = name.toLowerCase();
    
    for(int i = 0; i < name.length(); i++)
    {
      String tempName = name.substring(i, i + 1);
      if(alpha.indexOf(tempName) == -1)
        return false;
    }
    return true;
  }
  
  //checks to see if the numberfield is valid
  public boolean checkNum(String input)
  {
    String test = "0123456789";
    
    for(int i = 0; i < input.length(); i++)
    {
      String tempNum = input.substring(i, i + 1);
      if(test.indexOf(tempNum) == -1)
        return false;
    }
    return true;
  }
  
  //checks to see if the numberfield is valid
  public boolean checkNumText(String input)
  {
    String test = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVQXYZ1234567890.";
    
    for(int i = 0; i < input.length(); i++)
    {
      String tempNum = input.substring(i, i + 1);
      if(test.indexOf(tempNum) == -1)
        return false;
    }
    return true;
  }
  
  //checks to see if the email address is valid
  public boolean checkEmail(String input)
  {
    if(input == null)
      return false;
    
    String okList = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVQXYZ1234567890_.";
    
    if(input.indexOf("@") == -1)
      return false;
    
    int tempLoc = input.indexOf("@");
    String beginning = input.substring(0, tempLoc);
    String end = input.substring(tempLoc + 1);
    
    if(beginning.startsWith(".") 
         || beginning.endsWith(".")
         || end.startsWith(".")
         || end.endsWith("."))
      return false;
    
    if(end.indexOf(".") == -1)
      return false;
    
    for(int i = 0; i < beginning.length(); i++)
    {
      String tempBegin = beginning.substring(i, i + 1);
      if(okList.indexOf(tempBegin) == -1)
        return false;
    }
    
    for(int i = 0; i < end.length(); i++)
    {
      String tempEnd = end.substring(i, i + 1);
      if(okList.indexOf(tempEnd) == -1)
        return false;
    }
    
    return true;
  }
  
  
  //METHODS THAT CORR. TO ITEM CLASS
  
  //clears item ArrayList
  public void clearItems()
  { items.clear(); }
  
  //sets all attributes of an item and adds it to the item arraylist
  public void setItems(String name, String desc, int quantity, int itemNum, double price, String type)
  {
    Item tempItem = new Item(name, desc, quantity, itemNum, price, type);
    items.add(tempItem);
  }
  
  //returns length of shopping cart 
  public int getItemLength()
  { return items.size(); }
  
  //returns the type of said item
  public String getType(int num)
  {
    Item tempItem = (Item)items.get(num);
    return tempItem.getType();
  }
  
  //returns address of said item
  public String getName(int num)
  {
    Item tempItem = (Item)items.get(num);
    return tempItem.getName();
  }
  
  //returns description of said item
  public String getDesc(int num)
  {
    Item tempItem = (Item)items.get(num);
    return tempItem.getDesc();
  }
  
  //returns quantity of said item
  public int getQuantity(int num)
  {
    Item tempItem = (Item)items.get(num);
    return tempItem.getQuantity();
  }
  
  //returns item number of said item
  public int getItemNum(int num)
  {
    Item tempItem = (Item)items.get(num);
    return tempItem.getItemNum();
  }
  
  //returns price of said item
  public double getPrice(int num)
  {
    Item tempItem = (Item)items.get(num);
    return tempItem.getPrice() * tempItem.getQuantity();
  }
  
  //returns total price of all items combined
  public double getTotal()
  {
    double total = 0;
    for(int i = 0; i < items.size(); i++)
    {
      Item tempItem = (Item)items.get(i);
      total += tempItem.getPrice() * tempItem.getQuantity();
    }
    total *= 100;
    int temp = (int)total;
    total = temp;
    total /= 100;
    
    return total;
  }
  
  
  //ITEM CLASS
  
  public class Item
  {
    private String name, desc, type;
    private int quantity, itemNum;
    private double price;
    
    //constuctor - sets all fields to proper information
    public Item(String name, String desc, int quantity, int itemNum, double price, String type)
    {
      this.name = name;
      this.desc = desc;
      this.quantity = quantity;
      this.itemNum = itemNum;
      this.price = price;
      this.type = type;
    }
    
    //returns the type
    public String getType()
    { return type; }
    
    //returns the image location
    public String getName()
    { return name; }
    
    //returns the description
    public String getDesc()
    { return desc; }
    
    //returns the price
    public double getPrice()
    { return price; }
    
    //returns the quantity of the item
    public int getQuantity()
    { return quantity; }
    
    //sets the quantity of the item
    public void setQuantity(int quantity)
    { this.quantity = quantity; }
    
    //returns item number
    public int getItemNum()
    { return itemNum; }
  }
}